<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: epg/model/broadcast.proto

namespace Tellie\Epg\Model;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Generated from protobuf message <code>tellie.epg.model.Broadcast</code>
 */
class Broadcast extends \Google\Protobuf\Internal\Message
{
    /**
     * Generated from protobuf field <code>string id = 1;</code>
     */
    protected $id = '';
    /**
     * Generated from protobuf field <code>repeated .tellie.epg.model.LocalizedField name = 2;</code>
     */
    private $name;
    /**
     * Generated from protobuf field <code>string channel_id = 3;</code>
     */
    protected $channel_id = '';
    /**
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_date_time = 4;</code>
     */
    protected $start_date_time = null;
    /**
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_date_time = 5;</code>
     */
    protected $end_date_time = null;
    /**
     * Generated from protobuf field <code>repeated .tellie.epg.model.Genre genres = 6;</code>
     */
    private $genres;
    /**
     * Generated from protobuf field <code>repeated .tellie.epg.model.LocalizedField short_description = 7;</code>
     */
    private $short_description;
    /**
     * Generated from protobuf field <code>repeated .tellie.epg.model.LocalizedField long_description = 8;</code>
     */
    private $long_description;
    /**
     * Generated from protobuf field <code>optional .tellie.epg.model.Season season = 9;</code>
     */
    protected $season = null;
    /**
     * Generated from protobuf field <code>int32 episode_number = 10;</code>
     */
    protected $episode_number = 0;
    /**
     * Generated from protobuf field <code>bool replayable = 11;</code>
     */
    protected $replayable = false;
    /**
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp replay_end_date_time = 12;</code>
     */
    protected $replay_end_date_time = null;
    /**
     * Generated from protobuf field <code>bool fast_forward_during_replay = 13;</code>
     */
    protected $fast_forward_during_replay = false;
    /**
     * Generated from protobuf field <code>string cover_image = 14;</code>
     */
    protected $cover_image = '';
    /**
     * Generated from protobuf field <code>string wallpaper_image = 15;</code>
     */
    protected $wallpaper_image = '';
    /**
     * Generated from protobuf field <code>string stream_uri = 16;</code>
     */
    protected $stream_uri = '';
    /**
     * Generated from protobuf field <code>int32 replay_pre_padding = 17;</code>
     */
    protected $replay_pre_padding = 0;
    /**
     * Generated from protobuf field <code>int32 replay_post_padding = 18;</code>
     */
    protected $replay_post_padding = 0;
    /**
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp actual_start_date_time = 19;</code>
     */
    protected $actual_start_date_time = null;
    /**
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp actual_end_date_time = 20;</code>
     */
    protected $actual_end_date_time = null;
    /**
     * Generated from protobuf field <code>int32 recording_pre_padding = 21;</code>
     */
    protected $recording_pre_padding = 0;
    /**
     * Generated from protobuf field <code>int32 recording_post_padding = 22;</code>
     */
    protected $recording_post_padding = 0;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $id
     *     @type array<\Tellie\Epg\Model\LocalizedField>|\Google\Protobuf\Internal\RepeatedField $name
     *     @type string $channel_id
     *     @type \Google\Protobuf\Timestamp $start_date_time
     *     @type \Google\Protobuf\Timestamp $end_date_time
     *     @type array<\Tellie\Epg\Model\Genre>|\Google\Protobuf\Internal\RepeatedField $genres
     *     @type array<\Tellie\Epg\Model\LocalizedField>|\Google\Protobuf\Internal\RepeatedField $short_description
     *     @type array<\Tellie\Epg\Model\LocalizedField>|\Google\Protobuf\Internal\RepeatedField $long_description
     *     @type \Tellie\Epg\Model\Season $season
     *     @type int $episode_number
     *     @type bool $replayable
     *     @type \Google\Protobuf\Timestamp $replay_end_date_time
     *     @type bool $fast_forward_during_replay
     *     @type string $cover_image
     *     @type string $wallpaper_image
     *     @type string $stream_uri
     *     @type int $replay_pre_padding
     *     @type int $replay_post_padding
     *     @type \Google\Protobuf\Timestamp $actual_start_date_time
     *     @type \Google\Protobuf\Timestamp $actual_end_date_time
     *     @type int $recording_pre_padding
     *     @type int $recording_post_padding
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Epg\Model\Broadcast::initOnce();
        parent::__construct($data);
    }

    /**
     * Generated from protobuf field <code>string id = 1;</code>
     * @return string
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Generated from protobuf field <code>string id = 1;</code>
     * @param string $var
     * @return $this
     */
    public function setId($var)
    {
        GPBUtil::checkString($var, True);
        $this->id = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>repeated .tellie.epg.model.LocalizedField name = 2;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Generated from protobuf field <code>repeated .tellie.epg.model.LocalizedField name = 2;</code>
     * @param array<\Tellie\Epg\Model\LocalizedField>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setName($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Tellie\Epg\Model\LocalizedField::class);
        $this->name = $arr;

        return $this;
    }

    /**
     * Generated from protobuf field <code>string channel_id = 3;</code>
     * @return string
     */
    public function getChannelId()
    {
        return $this->channel_id;
    }

    /**
     * Generated from protobuf field <code>string channel_id = 3;</code>
     * @param string $var
     * @return $this
     */
    public function setChannelId($var)
    {
        GPBUtil::checkString($var, True);
        $this->channel_id = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_date_time = 4;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getStartDateTime()
    {
        return $this->start_date_time;
    }

    public function hasStartDateTime()
    {
        return isset($this->start_date_time);
    }

    public function clearStartDateTime()
    {
        unset($this->start_date_time);
    }

    /**
     * Generated from protobuf field <code>.google.protobuf.Timestamp start_date_time = 4;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setStartDateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->start_date_time = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_date_time = 5;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getEndDateTime()
    {
        return $this->end_date_time;
    }

    public function hasEndDateTime()
    {
        return isset($this->end_date_time);
    }

    public function clearEndDateTime()
    {
        unset($this->end_date_time);
    }

    /**
     * Generated from protobuf field <code>.google.protobuf.Timestamp end_date_time = 5;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setEndDateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->end_date_time = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>repeated .tellie.epg.model.Genre genres = 6;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getGenres()
    {
        return $this->genres;
    }

    /**
     * Generated from protobuf field <code>repeated .tellie.epg.model.Genre genres = 6;</code>
     * @param array<\Tellie\Epg\Model\Genre>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setGenres($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Tellie\Epg\Model\Genre::class);
        $this->genres = $arr;

        return $this;
    }

    /**
     * Generated from protobuf field <code>repeated .tellie.epg.model.LocalizedField short_description = 7;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getShortDescription()
    {
        return $this->short_description;
    }

    /**
     * Generated from protobuf field <code>repeated .tellie.epg.model.LocalizedField short_description = 7;</code>
     * @param array<\Tellie\Epg\Model\LocalizedField>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setShortDescription($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Tellie\Epg\Model\LocalizedField::class);
        $this->short_description = $arr;

        return $this;
    }

    /**
     * Generated from protobuf field <code>repeated .tellie.epg.model.LocalizedField long_description = 8;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getLongDescription()
    {
        return $this->long_description;
    }

    /**
     * Generated from protobuf field <code>repeated .tellie.epg.model.LocalizedField long_description = 8;</code>
     * @param array<\Tellie\Epg\Model\LocalizedField>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setLongDescription($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Tellie\Epg\Model\LocalizedField::class);
        $this->long_description = $arr;

        return $this;
    }

    /**
     * Generated from protobuf field <code>optional .tellie.epg.model.Season season = 9;</code>
     * @return \Tellie\Epg\Model\Season|null
     */
    public function getSeason()
    {
        return $this->season;
    }

    public function hasSeason()
    {
        return isset($this->season);
    }

    public function clearSeason()
    {
        unset($this->season);
    }

    /**
     * Generated from protobuf field <code>optional .tellie.epg.model.Season season = 9;</code>
     * @param \Tellie\Epg\Model\Season $var
     * @return $this
     */
    public function setSeason($var)
    {
        GPBUtil::checkMessage($var, \Tellie\Epg\Model\Season::class);
        $this->season = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>int32 episode_number = 10;</code>
     * @return int
     */
    public function getEpisodeNumber()
    {
        return $this->episode_number;
    }

    /**
     * Generated from protobuf field <code>int32 episode_number = 10;</code>
     * @param int $var
     * @return $this
     */
    public function setEpisodeNumber($var)
    {
        GPBUtil::checkInt32($var);
        $this->episode_number = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>bool replayable = 11;</code>
     * @return bool
     */
    public function getReplayable()
    {
        return $this->replayable;
    }

    /**
     * Generated from protobuf field <code>bool replayable = 11;</code>
     * @param bool $var
     * @return $this
     */
    public function setReplayable($var)
    {
        GPBUtil::checkBool($var);
        $this->replayable = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp replay_end_date_time = 12;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getReplayEndDateTime()
    {
        return $this->replay_end_date_time;
    }

    public function hasReplayEndDateTime()
    {
        return isset($this->replay_end_date_time);
    }

    public function clearReplayEndDateTime()
    {
        unset($this->replay_end_date_time);
    }

    /**
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp replay_end_date_time = 12;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setReplayEndDateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->replay_end_date_time = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>bool fast_forward_during_replay = 13;</code>
     * @return bool
     */
    public function getFastForwardDuringReplay()
    {
        return $this->fast_forward_during_replay;
    }

    /**
     * Generated from protobuf field <code>bool fast_forward_during_replay = 13;</code>
     * @param bool $var
     * @return $this
     */
    public function setFastForwardDuringReplay($var)
    {
        GPBUtil::checkBool($var);
        $this->fast_forward_during_replay = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>string cover_image = 14;</code>
     * @return string
     */
    public function getCoverImage()
    {
        return $this->cover_image;
    }

    /**
     * Generated from protobuf field <code>string cover_image = 14;</code>
     * @param string $var
     * @return $this
     */
    public function setCoverImage($var)
    {
        GPBUtil::checkString($var, True);
        $this->cover_image = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>string wallpaper_image = 15;</code>
     * @return string
     */
    public function getWallpaperImage()
    {
        return $this->wallpaper_image;
    }

    /**
     * Generated from protobuf field <code>string wallpaper_image = 15;</code>
     * @param string $var
     * @return $this
     */
    public function setWallpaperImage($var)
    {
        GPBUtil::checkString($var, True);
        $this->wallpaper_image = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>string stream_uri = 16;</code>
     * @return string
     */
    public function getStreamUri()
    {
        return $this->stream_uri;
    }

    /**
     * Generated from protobuf field <code>string stream_uri = 16;</code>
     * @param string $var
     * @return $this
     */
    public function setStreamUri($var)
    {
        GPBUtil::checkString($var, True);
        $this->stream_uri = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>int32 replay_pre_padding = 17;</code>
     * @return int
     */
    public function getReplayPrePadding()
    {
        return $this->replay_pre_padding;
    }

    /**
     * Generated from protobuf field <code>int32 replay_pre_padding = 17;</code>
     * @param int $var
     * @return $this
     */
    public function setReplayPrePadding($var)
    {
        GPBUtil::checkInt32($var);
        $this->replay_pre_padding = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>int32 replay_post_padding = 18;</code>
     * @return int
     */
    public function getReplayPostPadding()
    {
        return $this->replay_post_padding;
    }

    /**
     * Generated from protobuf field <code>int32 replay_post_padding = 18;</code>
     * @param int $var
     * @return $this
     */
    public function setReplayPostPadding($var)
    {
        GPBUtil::checkInt32($var);
        $this->replay_post_padding = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp actual_start_date_time = 19;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getActualStartDateTime()
    {
        return $this->actual_start_date_time;
    }

    public function hasActualStartDateTime()
    {
        return isset($this->actual_start_date_time);
    }

    public function clearActualStartDateTime()
    {
        unset($this->actual_start_date_time);
    }

    /**
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp actual_start_date_time = 19;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setActualStartDateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->actual_start_date_time = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp actual_end_date_time = 20;</code>
     * @return \Google\Protobuf\Timestamp|null
     */
    public function getActualEndDateTime()
    {
        return $this->actual_end_date_time;
    }

    public function hasActualEndDateTime()
    {
        return isset($this->actual_end_date_time);
    }

    public function clearActualEndDateTime()
    {
        unset($this->actual_end_date_time);
    }

    /**
     * Generated from protobuf field <code>optional .google.protobuf.Timestamp actual_end_date_time = 20;</code>
     * @param \Google\Protobuf\Timestamp $var
     * @return $this
     */
    public function setActualEndDateTime($var)
    {
        GPBUtil::checkMessage($var, \Google\Protobuf\Timestamp::class);
        $this->actual_end_date_time = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>int32 recording_pre_padding = 21;</code>
     * @return int
     */
    public function getRecordingPrePadding()
    {
        return $this->recording_pre_padding;
    }

    /**
     * Generated from protobuf field <code>int32 recording_pre_padding = 21;</code>
     * @param int $var
     * @return $this
     */
    public function setRecordingPrePadding($var)
    {
        GPBUtil::checkInt32($var);
        $this->recording_pre_padding = $var;

        return $this;
    }

    /**
     * Generated from protobuf field <code>int32 recording_post_padding = 22;</code>
     * @return int
     */
    public function getRecordingPostPadding()
    {
        return $this->recording_post_padding;
    }

    /**
     * Generated from protobuf field <code>int32 recording_post_padding = 22;</code>
     * @param int $var
     * @return $this
     */
    public function setRecordingPostPadding($var)
    {
        GPBUtil::checkInt32($var);
        $this->recording_post_padding = $var;

        return $this;
    }

}

